var Ajuste_Service = function(Lanctoestoq_Repository,Itlanctoest_Repository,restEngine,localStorageEngine,Ajuste_Repository,ZHPromise, ScreenService, templateManager, ValidacoesEstoque_Service) {
	this.idOrdAjuInv=null;
	this.idTipoCustoBrut=null;
	this.idTipoCustoLiq=null;
	
    this.retornaParamUnidade = function(cdFilialOpcional) {
        var cdFilialFiltrada = cdFilialOpcional || "FILIAL_LOGADA";
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": cdFilialFiltrada
            }
        ];
        return restEngine.post("est#/crud/paramfilial", {
            "requestType": "FilterData",
            "filter": filter
        });
    }; 
    
	this.setIdOrdAjuInv = function(args){
		/* ADICIONADO PARA TRATAR CONSIDERAR FILIAL DO FILTRO E NÃO A LOGADA */
		var cdfilial = args.owner.appliedFilter.FILTER_ROW.CDFILIAL;
		this.retornaParamUnidade(cdfilial).then(function(paramfilial){
			this.idOrdAjuInv=paramfilial.dataset.paramfilial[0].IDORDAJUINVE;
		}.bind(this));
	};

	this.getOperadorLogado = function(){
		var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];

        return localStorageEngine.download("est#/crud/operador", filter);
	};

	this.setParamImpl = function(args){
		var cdfilial = args.owner.appliedFilter.FILTER_ROW.CDFILIAL;
		this.retornaParamUnidade(cdfilial).then(function(paramfilial){
			paramfilial = paramfilial.dataset.paramfilial[0];
			this.idOrdAjuInv=paramfilial.IDORDIMPLANT; 
			var idtcusnfroma=paramfilial.IDTCUSNFROMA||'3';
			switch(idtcusnfroma){
				case '3':
				case '4':
					this.idTipoCustoLiq = '3';
					this.idTipoCustoBrut = '4';
				break;
				case '8':
				case '9':
					this.idTipoCustoLiq = '8';
					this.idTipoCustoBrut = '9';
				break;
				case '1':
				case '2':
					this.idTipoCustoLiq = '1';
					this.idTipoCustoBrut = '2';
				break;
				default:
					this.idTipoCustoLiq = paramfilial.IDTCUSNFROMA;
					this.idTipoCustoBrut = this.idTipoCustoLiq;
		  } 
		}.bind(this));
	};

	this.getOrdemAjuste = function(){
		return this.idOrdAjuInv === 'P' ? 'primeiro do dia' : 'último do dia';
	};
	
	this.getIdordemclc = function(){
		return this.idOrdAjuInv === 'P' ? 0 : 'U';
	}; 

	this.editAjuste = function(row){
		return Lanctoestoq_Repository.saveLanctoestoq(row);
	};

	this.saveImportRows = function(itemRows, ajusteRow){
		itemRows.forEach(function(itemRow) {
			if(!itemRow.QTTOTLANCTO)
				itemRow.QTTOTLANCTO = 0;
			if(itemRow.QTTOTLANCTO.toString().search(',') !== -1){
				itemRow.QTTOTLANCTO = $.currency.unmaskString(itemRow.QTTOTLANCTO,{decimal:',',thousands:'.'});
			}
			if(!itemRow.VRUNILANCTO)
				itemRow.VRUNILANCTO = 0;
			if(itemRow.VRUNILANCTO.toString().search(',') !== -1){
				itemRow.VRUNILANCTO = $.currency.unmaskString(itemRow.VRUNILANCTO,{decimal:',',thousands:'.'});
			}
			if(!itemRow.VRUNITBRUT)
				itemRow.VRUNITBRUT = 0;
			if(itemRow.VRUNITBRUT.toString().search(',') !== -1){
				itemRow.VRUNITBRUT = $.currency.unmaskString(itemRow.VRUNITBRUT,{decimal:',',thousands:'.'});
			}
			if(!itemRow.VRTOTLANCTO)
				itemRow.VRTOTLANCTO = 0;

			itemRow.VRTOTLANCTO = itemRow.VRUNILANCTO * itemRow.QTTOTLANCTO;
			itemRow.VRLANCTOEST = itemRow.VRTOTLANCTO;
			itemRow.VRLANCTOBRUT = itemRow.VRUNITBRUT * itemRow.QTTOTLANCTO;

			itemRow.QTLANCTOEST = itemRow.QTTOTLANCTO*(itemRow.VRFATOCONV||1);

			itemRow.IDEVOLESTOQ = 'N';
			itemRow.CDFILIAL=ajusteRow.CDFILIAL;
			itemRow.CDFILIMOVI=ajusteRow.CDFILIMOVI;
			itemRow.DTLANCMOVI = ajusteRow.DTLANCESTQ = moment(ajusteRow.DTLANCESTQ,'DD/MM/YYYY hh:mm:ss').format('DD/MM/YYYY');
			itemRow.CDOPERADOR=ajusteRow.CDOPERADOR;
			itemRow.IDORDEMCLC = this.idOrdAjuInv == 'P' ? 0 : 'U';

			itemRow.NRLANCESTQ=ajusteRow.NRLANCESTQ;

            delete itemRow.__rightActions;
		}.bind(this));
		
		if(itemRows.length <= 600){
			return Ajuste_Repository.saveItlanctoest(itemRows);
		}
		else{
			var newRows = Util.clone(itemRows, ["__rightActions", "__leftActions"]);
			ScreenService.showMessage('Devido ao grande volume de dados este processo pode levar alguns minutos.');
			return saveDatasetPagination('est_ajuste#/crud/itlanctoest/save', newRows);
		}
	};

	this.save = function(itemRow,ajusteRow){
		if(!itemRow.QTTOTLANCTO)
				itemRow.QTTOTLANCTO = 0; 
		if(itemRow.QTTOTLANCTO.toString().search(',') !== -1){
			itemRow.QTTOTLANCTO = $.currency.unmaskString(itemRow.QTTOTLANCTO,{decimal:',',thousands:'.'});
		}
		
		if(!itemRow.VRUNILANCTO)
				itemRow.VRUNILANCTO = 0;
		if(itemRow.VRUNILANCTO.toString().search(',') !== -1){
			itemRow.VRUNILANCTO = $.currency.unmaskString(itemRow.VRUNILANCTO,{decimal:',',thousands:'.'});
		}
		
		if(!itemRow.VRUNITBRUT)
				itemRow.VRUNITBRUT = 0;
		if(itemRow.VRUNITBRUT.toString().search(',') !== -1){
			itemRow.VRUNITBRUT = $.currency.unmaskString(itemRow.VRUNITBRUT,{decimal:',',thousands:'.'});
		}
		
		if(!itemRow.VRTOTLANCTO)
				itemRow.VRTOTLANCTO = 0;

		itemRow.VRTOTLANCTO = itemRow.VRUNILANCTO * itemRow.QTTOTLANCTO;
		itemRow.VRLANCTOEST = itemRow.VRTOTLANCTO;
		itemRow.VRLANCTOBRUT = itemRow.VRUNITBRUT * itemRow.QTTOTLANCTO;

		itemRow.QTLANCTOEST = itemRow.QTTOTLANCTO*(itemRow.VRFATOCONV||1);

		itemRow.IDEVOLESTOQ = 'N';
		itemRow.CDFILIAL=ajusteRow.CDFILIAL;
		itemRow.CDFILIMOVI=ajusteRow.CDFILIMOVI;
		itemRow.DTLANCMOVI = ajusteRow.DTLANCESTQ = moment(ajusteRow.DTLANCESTQ,'DD/MM/YYYY hh:mm:ss').format('DD/MM/YYYY');
		itemRow.CDOPERADOR=ajusteRow.CDOPERADOR;
		itemRow.IDORDEMCLC = this.idOrdAjuInv == 'P' ? 0 : 'U';

		if(ajusteRow.__is_new){
			return Lanctoestoq_Repository.saveLanctoestoq(ajusteRow,itemRow);
		}else{
			itemRow.NRLANCESTQ=ajusteRow.NRLANCESTQ;
			return Itlanctoest_Repository.saveItlanctoestValidation(itemRow);
		}
	};
	
	function saveDatasetPagination(route, dataToSave, datasetName = 'columnsToReturn', page = 0, registers = {}){
		const rowPerPage = 600;
		var maxPages = Math.ceil((dataToSave.length / rowPerPage));
		
		var paginatedData = dataToSave.filter((row, index) =>{
            	if(index >= rowPerPage*page &&  index < rowPerPage*(page+1))
            		return true;
            	else
            		return false;
            });
		return Ajuste_Repository.saveDataset(route, paginatedData).then(callback => {
			var registersResult = callback.dataset[datasetName];
			
			if(!registers.hasOwnProperty('dataset'))
				registers.dataset = callback.dataset;
			else
            	registers.dataset[datasetName] = registers.dataset[datasetName].concat(registersResult);
            	
            if (page >= maxPages) {
                return registers;
            } else {
                page++;
                return saveDatasetPagination(route, dataToSave, datasetName, page, registers);
            }
		});
		
	}

	this.filialControlEstq = function(){
		var defer = ZHPromise.defer();
		this.retornaParamUnidade().then(
			function(success){
				if(success.dataset.paramfilial[0].IDCTRLESTQ === 'S'){
					defer.resolve();
				}else{
					defer.reject('Unidade não controla estoque');
				}
			},
			function(error){
				defer.reject('Unidade não controla estoque');
			}
		);
		return defer;
	};
	

	this.validaItem = function(currentRow,data){
		var validacao = true;

		let arrayFieldsToSetDefaultValue = ['CDALMOXARIFE', 'CDLOCALESTOQ', 'NRLOTEESTQ', 'NRSUBLOTE'];
		data.forEach(row => {
			arrayFieldsToSetDefaultValue.forEach( field => {
				if(!row[field])
					row[field] = ' ';
				else
					row[field] =  row[field] == '' ? ' ' : row[field];
			});
		});
		
		data.forEach(function(row) {
			if(currentRow.CDPRODUTO === row.CDPRODUTO && currentRow !== row && currentRow.CDALMOXARIFE === row.CDALMOXARIFE && currentRow.CDLOCALESTOQ === row.CDLOCALESTOQ && currentRow.NRLOTEESTQ === row.NRLOTEESTQ)
				validacao = false;
		});

		return validacao;
	};

	this.geraNrsequitem = function(itens){
		var nrsequitemArray=[0];
		itens.forEach(function(item){
			if(item.NRSEQUITEM)
				nrsequitemArray.push(item.NRSEQUITEM);
		});
		return ('000'+(Math.max.apply(this,nrsequitemArray)+1)).slice(-4);
	};

	this.deleteLancamento = function(row){
		return Ajuste_Repository.deleteLancto(row);
	};

	this.importProducts = function(CDGRUPPROD, CDORDENA, CDFILIAL, DTLANCMOVI, IDGRUPPROD) {
		var IDORDEMCLC = this.idOrdAjuInv =='P' ? 0 : 'U';

		var filter = [
			{
				"name": "CDGRUPPROD",
				"operator": "=",
				"value": CDGRUPPROD
			},
			{
				"name": "CDORDENA",
				"operator": "=",
				"value": CDORDENA
			},
			{
				"name": "CDFILIAL",
				"operator": "=",
				"value": CDFILIAL
			},
			{
				"name": "CDALMOXARIFE",
				"operator": "=",
				"value": ' '
			},
			{
				"name": "CDLOCALESTOQ",
				"operator": "=",
				"value": ' '
			},
			{
				"name": "NRLOTEESTQ",
				"operator": "=",
				"value": ' '
			},
			{
				"name": "NRSUBLOTE",
				"operator": "=",
				"value": ' '
			},
			{
				"name": "IDORDEMCLC",
				"operator": "=",
				"value": IDORDEMCLC
			},
			{
				"name": "DTLANCMOVI",
				"operator": "=",
				"value": DTLANCMOVI
			},
			{
				"name": "IDGRUPPROD",
				"operator": "=",
				"value": IDGRUPPROD
			},
		];
		return Ajuste_Repository.importProducts(filter);
	};

	this.deleteItem = function(row){
		return Ajuste_Repository.deleteItem(row);
	};

	this.validaAjuste = function(rowProduto, dtLanc) {
		if(rowProduto.IDTIPOMOVI == 1) {
			var idOrdemClc = this.idOrdAjuInv == 'P' ? 0 : 'U';
			var filter = [
				{
					"name": "CDFILIMOVI",
					"operator": "=",
					"value": rowProduto.CDFILIMOVI
				},
				{
					"name": "CDPRODMOVI",
					"operator": "=",
					"value": rowProduto.CDPRODMOVI
				},
				{
					"name": "CDALMOXARIFE",
					"operator": "=",
					"value": rowProduto.CDALMOXARIFE
				},
				{
					"name": "CDLOCALESTOQ",
					"operator": "=",
					"value": rowProduto.CDLOCALESTOQ
				},
				{
					"name": "NRLOTEESTQ",
					"operator": "=",
					"value": rowProduto.NRLOTEESTQ
				},
				{
					"name": "NRSUBLOTE",
					"operator": "=",
					"value": rowProduto.NRSUBLOTE
				},
				{
					"name": "DTLANCMOVI",
					"operator": "=",
					"value": dtLanc
				},
				{
					"name": "IDORDEMCLC",
					"operator": "=",
					"value": idOrdemClc
				},
				{
					"name": "IDAJUSTEIMPORT",
					"operator": "=",
					"value": rowProduto.IDAJUSTEIMPORT || 'N'
				}
			];

			return Ajuste_Repository.validaAjuste(filter);
		}else
			return ZHPromise.when();
	};
	
	this.openPopupCusto = function(arrayCustos, popup){
		popup.dataSourceFilter = [];
		var popupPromisse = ZHPromise.defer();
		let data = popup.dataSource.data;
		let produtosInvalidos = [];
		arrayCustos.forEach(rowCusto =>{
			
			let rowItem = rowCusto.item;
			let valrAnte = rowCusto.valrAnte*rowItem.VRFATOCONV;
			let qtdeAnte = rowCusto.qtdeAnte;
			let valrMedi = rowCusto.valrMedi*rowItem.VRFATOCONV;
			let qtdeAtu = $.currency.unmaskString(rowItem.QTTOTLANCTO,{decimal:',',thousands:'.'});
			let valrAtu = valrMedi*qtdeAtu;
			let qntValida = this.validaQuantidade(valrAnte, qtdeAnte, valrMedi, qtdeAtu, valrAtu , rowItem.VRFATOCONV , rowItem.VRPTOLAJUSINV);
			data.push({'SITUACAO' : rowItem.CDARVPROD+' - '+rowItem.NMPRODUTO, 'VALORTOT' : NaN, 'QUANTIDADE' : NaN, 'CUSTMEDIO' : NaN});
			data.push({'SITUACAO' : 'Atual', 'VALORTOT' : valrAnte, 'QUANTIDADE' : qtdeAnte, 'CUSTMEDIO' : valrMedi});
			data.push({'SITUACAO' : 'Após Ajuste', 'VALORTOT' : valrAtu, 'QUANTIDADE' : qtdeAtu, 'CUSTMEDIO' : valrMedi , 'qntValida' : qntValida});
			
			if(!qntValida){
				data[0].ajusteValido = false; 
				produtosInvalidos.push(rowItem.CDARVPROD);
			}else{
				data[0].ajusteValido = true; 
			}
		}); 
		
		//montar datasource para mostrar no grid
		popup.promisse = popupPromisse;
		ScreenService.openPopup(popup);
		
		// troca Style das rows invalidas na widget Produto
		this.quantidadeInvalida(produtosInvalidos);
		return popupPromisse;
	};
	
	this.validaQuantidade = function(valrAnte, qtdeAnte, valrMedi, qtdeAtu, valrAtu , VRFATOCONV, VRPTOLAJUSINV  ){
            if(VRPTOLAJUSINV > 0 && VRPTOLAJUSINV !=null){
                if (valrAnte * VRFATOCONV !=  0){
                    if (Math.abs(((valrMedi*qtdeAtu*VRFATOCONV*100)/valrAnte*VRFATOCONV)-100) > VRFATOCONV){
                        return  false ;
                    }
                }
            }
         return true ; 
    };
    
	this.quantidadeInvalida =  function(produtos){
		let rowsProduto = templateManager.container.getWidget("Produtos").dataSource.data;
        if(produtos.length > 0){
            rowsProduto.forEach(row => {
            	produtos.forEach (produto => {
                if(produto === row.CDARVPROD){
                    row.qntValida =  false;
                }else {
                	 row.qntValida =  true;
                }     
            	});
			 });    
        }else {
        	 rowsProduto.forEach(row => {
        	 	 row.qntValida =  true;
        	 });
        }		
    };
    
    this.importarProdutosTxt = function(row){
    	return Ajuste_Repository.importarProdutosTxt(row);
    };
    
	this.importProductsFilial = function(CDORDENA, CDFILIAL, DTLANCESTQ, DATAPROC) {
		var filter = [
			{
				"name": "CDORDENA",
				"operator": "=",
				"value": CDORDENA
			},
			{
				"name": "P_CDFILIAL",
				"operator": "=",
				"value": CDFILIAL
			},
			{
				"name": "DTLANCESTQ",
				"operator": "=",
				"value": DTLANCESTQ
			},
			{
				"name": "P_DATAPROC",
				"operator": "=",
				"value": DATAPROC
			}
		];
		return Ajuste_Repository.importProductsFilial(filter);
	};

    this.gerarImplantacao = function(rowAjuste, itens){
    	return ValidacoesEstoque_Service.validaDataLancamento(rowAjuste.CDFILIAL,rowAjuste.DTLANCESTQ,'AJUSTE_IMP','EST',null).then(
    		() => {
				return this.save(itens.pop(), rowAjuste).then(
					success => {
						if(itens.length > 0){
							rowAjuste.NRLANCESTQ = success.dataset["/lanctoestoq/save"].NRLANCESTQ;
							return this.saveImportRows(itens, rowAjuste);	
						}
					}
				).catch(
					error => {
						if(error.data){
		                    ScreenService.showMessage(error.data.error);
		                }else{
		                    ScreenService.showMessage(error);
		                }	
					}
				);
    		}
    	).catch(
    		error => {
    			if(error.data){
                    ScreenService.showMessage(error.data.error);
                }else{
                    ScreenService.showMessage(error);
                }
    		}
    	);
    };
    
    this.questionConsolidaEmProdEstoque = function(datasetProdutos){
    	var defer = ZHPromise.defer();
    	var boolQuestion =  datasetProdutos.some(row => {
	    	return datasetProdutos.some(row2 => {
	                            if( (row2.NRSEQUITEM != row.NRSEQUITEM) && 
	                                (row2.CDPRODMOVI == row.CDPRODMOVI) &&
	                                (row2.NRLOTEESTQ == row.NRLOTEESTQ) &&
	                                (row2.CDALMOXARIFE == row.CDALMOXARIFE) &&
	                                (row2.CDLOCALESTOQ == row.CDLOCALESTOQ) &&
	                                (row2.NRSUBLOTE == row.NRSUBLOTE) )
	                                {
	                                    return true;
	                                }
	                        });
    	});
    	if(boolQuestion){
	    	ScreenService.confirmMessage('Existem dois ou mais produtos relacionados ao mesmo produto de estoque. Deseja consolidar a quantidade lançada para o produto de estoque?',
		        'question',
		        function() { //sim
		            defer.resolve(true);
		        }.bind(this),
		        function() { //não
		            defer.resolve(false);
	        }.bind(this));
    	}else{
    		defer.resolve(false);
    	}
    	return defer;
    };
    
    this.getImportMessage = function(importGroupCode){
    	
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Ajuste_Service', Ajuste_Service);
});