function Est32000_GiroDeEstoque_Controller(ZhFilterPreferences, ScreenService, General, templateManager, ProductField, ProdTreeGroup, localStorageEngine, Est32000_GiroDeEstoque_Service) {

	this.enableDisableData = function(widget) {
		var PARAM = widget.currentRow.PARAM;

		if(PARAM == 'D'){
			widget.getField('NRDIAS').readOnly = false;
			widget.getField('DATAINI').readOnly = true;
			widget.getField('DATAFIN').readOnly = true;
			
			widget.getField('NRDIAS').validations = {"min": {"limit": 1}, "max": {"value": 999}};
			widget.getField('DATAINI').validations = {};
			widget.getField('DATAFIN').validations = {};
			
		}else if(PARAM == 'P'){
			widget.getField('NRDIAS').readOnly = true;
			widget.getField('DATAINI').readOnly = false;
			widget.getField('DATAFIN').readOnly = false;
			
			widget.getField('NRDIAS').validations = {};
			widget.getField('DATAINI').validations = {"required": true};
			widget.getField('DATAFIN').validations = {"required": true};
		}
		
		widget.getField('NRDIAS').reload();
		widget.getField('DATAINI').reload();
		widget.getField('DATAFIN').reload();
	
	};

	this.setNameLayout = function(args){
        var widget = args.owner;
        if (!widget.hasOwnProperty('labelPrincipal')){
            widget.labelPrincipal = widget.label;
        }
        if (args.e.layout.ID == 'ORIGINAL'){
            widget.container.label = widget.labelPrincipal;
            widget.label = widget.labelPrincipal;
        }else{
            widget.container.label = args.e.layout.LABEL_TO_PREFERENCE;
            widget.label = args.e.layout.LABEL_TO_PREFERENCE;
        }
    };
    
    this.openFilter = function(widget){
        this.setFieldsGerais(widget);
        var rowsToSet = {};
        this.getFilialLogada().then(function(success) {
            rowsToSet.CDFILIAL = success.dataset.filial[0].CDFILIAL;
            rowsToSet.NMFILIAL = success.dataset.filial[0].NMFILIAL;
            rowsToSet.PARAM = 'D';
            rowsToSet.DADOSPOR = '1';
            rowsToSet.ORDENA = '0';
            
            ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(function(){
                templateManager.container.getActiveWidget().getAction('close').isVisible = false;
                this.changeFilial(widget);
            }.bind(this));
        }.bind(this));
    };
    
    this.setFieldsGerais = function(widget){
        templateManager.container.fieldsGerais = widget.fields.map(function(field){return field.name;});
    }; 
	
	this.getFilialLogada = function() {
        var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": "FILIAL_LOGADA"
                }
		    ];
        return General.callRestEngine('est#/crud/filial', 'FilterData', filter);
    };
	
	//Parâmetros Filtro
    this.changeFilter = function(widget, preference) {
        var filterRow = preference.FILTER_ROW;
        var filtro = [];
        
        var mascara = 20 - filterRow.CDARVPRODFIN.length;
		var produtoFinal = filterRow.CDARVPRODFIN + 'z'.repeat(mascara).substring(0, mascara);
		
		if(filterRow.DATAINI && filterRow.DATAFIN && !filterRow.NRDIAS){
		    
		    var dtini = filterRow.DATAINI.split('/').reverse().join('/');
		    var dtfin = filterRow.DATAFIN.split('/').reverse().join('/');
		    
		    var ini = new Date(dtini); // Data ini
            var fin = new Date(dtfin); // Data fin
            var diff = Math.abs(fin.getTime() - ini.getTime()); // Subtrai uma data pela outra
            var days = Math.ceil(diff / (1000 * 60 * 60 * 24)); // Divide o total pelo total de milisegundos correspondentes a 1 dia. (1000 milisegundos = 1 segundo).
            
            filterRow.NRDIAS = days;
		}
        
        filtro= [
            {
                "name": "CDFILIAL",
                "operator":"=",
                "value": filterRow.CDFILIAL
            },
            {
                "name":"CDALMOXARIFE",
                "operator":"=",
                "value": filterRow.CDALMOXARIFE ? filterRow.CDALMOXARIFE : null
            },
            {
                "name":"CDLOCALESTOQ",
                "operator":"=",
                "value": filterRow.CDLOCALESTOQ ? filterRow.CDLOCALESTOQ : null
            },
            {
                "name":"CDPRODINI",
                "operator":"=",
                "value": filterRow.CDARVPRODINI ? filterRow.CDARVPRODINI : null
            },
            {
                "name":"CDPRODFIN",
                "operator":"=",
                "value": produtoFinal
            },
            {
                "name":"NRDIAS",
                "operator":"=",
                "value": filterRow.NRDIAS ? filterRow.NRDIAS : null
            },
            {
                "name": "ORDENA",
                "operator": "=",
                "value": filterRow.ORDENA
            },
            {
                "name": "PARAM",
                "operator": "=",
                "value": filterRow.PARAM
            },
            {
                "name": "DATAINI",
                "operator": "=",
                "value": filterRow.DATAINI ? filterRow.DATAINI : null
            },
            {
                "name": "DATAFIN",
                "operator": "=",
                "value": filterRow.DATAFIN ? filterRow.DATAFIN : null
            },
            {
                "name": "DADOSPOR",
                "operator": "=",
                "value": filterRow.DADOSPOR
            }
        ];
        
        widget.dataSourceFilter = filtro;
        widget.reload();
        
    };
    
    // Habilita/Desabilita Almoxarifado
    this.changeFilial = function (widget) {
        var cdfilial = widget.currentRow.CDFILIAL;

        if(cdfilial) {
            Est32000_GiroDeEstoque_Service.getParamFilial(cdfilial).then(function (paramfilial) {
                widget.getField("DSALMOXARIFE").readOnly = !((paramfilial.dataset.paramfilial[0].IDCTRLESTQ == 'S') && (paramfilial.dataset.paramfilial[0].IDUTILALMOX  == 'S'));
                
                widget.getField("DSALMOXARIFE").dataSourceFilter[0].value = cdfilial;
                widget.getField("DSALMOXARIFE").reload();
                widget.getField("CDALMOXARIFE").reload();
                
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        }else{
            widget.getField("DSALMOXARIFE").readOnly = true;
            widget.getField("DSLOCALESTOQ").readOnly = true;
        }
        widget.currentRow.DSALMOXARIFE = '';
        widget.currentRow.DSLOCALESTOQ = '';
        widget.currentRow.CDALMOXARIFE = '';
        widget.currentRow.CDLOCALESTOQ = '';
    };

    // Habilita/Desabilita Localização
    this.changeAlmoxarifado = function (args) {
        var cdfilial     = args.row.CDFILIAL;
        var cdalmoxarife = args.row.CDALMOXARIFE;
        if(cdfilial && cdalmoxarife) {
            Est32000_GiroDeEstoque_Service.getParamFilial(cdfilial).then(function (paramfilial) {
                args.owner.field.widget.getField("DSLOCALESTOQ").readOnly = !((paramfilial.dataset.paramfilial[0].IDCTRLESTQ == 'S') && (paramfilial.dataset.paramfilial[0].IDUTILLCESTQ == 'S'));
                
                args.owner.field.widget.getField("DSLOCALESTOQ").dataSourceFilter[0].value = cdfilial;
                args.owner.field.widget.getField("DSLOCALESTOQ").dataSourceFilter[1].value = cdalmoxarife;
                
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        }else{
            args.owner.field.widget.getField("DSLOCALESTOQ").readOnly = true;
        }
        args.row.DSLOCALESTOQ = '';
        args.row.CDLOCALESTOQ = '';
    };
    
    this.changeFilterLancEstoq = function(args){
        var cdfilial = args.owner.field.widget.currentRow.CDFILIAL;   
        var dtlancestq = args.owner.field.widget.currentRow.DTLANCESTQ;   
        args.owner.field.widget.getField('NRLANCESTQ').dataSourceFilter[0].value = cdfilial;
        args.owner.field.widget.getField('NRLANCESTQ').dataSourceFilter[1].value = dtlancestq;
        if(dtlancestq != ""){
            args.owner.field.widget.getField('NRLANCESTQ').reload();
            templateManager.container.getWidget('EmissaoInventarioGrid').dataSource.name = "est_relatorios#/crud/itlanctoest_produto";
        }else{
            templateManager.container.getWidget('EmissaoInventarioGrid').dataSource.name = "est_relatorios#/produto_posestatu_paramfilial";
        }
    };
    
    this.changeFilterLancEstoqByFilial = function(args){
        var cdfilial = args.owner.field.widget.currentRow.CDFILIAL;   
        var dtlancestq = args.owner.field.widget.currentRow.DTLANCESTQ;   
        
        args.owner.field.widget.getField('NRLANCESTQ').dataSourceFilter[0].value = cdfilial;
        args.owner.field.widget.getField('NRLANCESTQ').dataSourceFilter[1].value = dtlancestq;
        args.owner.field.widget.currentRow.NRLANCESTQ = "";
        if(dtlancestq != ""){
            args.owner.field.widget.getField('NRLANCESTQ').reload();
            templateManager.container.getWidget('EmissaoInventarioGrid').dataSource.name = "est_relatorios#/crud/itlanctoest_produto";
        }else{
            templateManager.container.getWidget('EmissaoInventarioGrid').dataSource.name = "est_relatorios#/produto_posestatu_paramfilial";
        }
    };
    
    this.validaCamposVisiveisGrid = function(widget, preference){
        var filterPopup = preference.FILTER_ROW;
        
        if(filterPopup.DADOSPOR == '1'){ // QTDE
            widget.getField('QTESTOQDIA').isVisible = true;
            widget.getField('QTLANCTOEST').isVisible = true;
            widget.getField('VRESTOQDIA').isVisible = false;
            widget.getField('VRTOTLANCTO').isVisible = false;
        }else{ // VALOR
            widget.getField('QTESTOQDIA').isVisible = false;
            widget.getField('QTLANCTOEST').isVisible = false;
            widget.getField('VRESTOQDIA').isVisible = true;
            widget.getField('VRTOTLANCTO').isVisible = true;
        }
    };
    
    this.setTotalizadores = function(widget){
        /*var qtdeProdutos = widget.dataSource.data.length;
        
        var filterPopup = widget.appliedFilter.FILTER_ROW;
        var totQTESTOQDIA = parseFloat(0);
        var totQTLANCTOEST = parseFloat(0);
        var totVRESTOQDIA = parseFloat(0);
        var totVRTOTLANCTO = parseFloat(0);
        var totDIASRESTANTES = parseFloat(0);
        
        widget.dataSource.data.forEach(row => {
            totQTESTOQDIA += parseFloat(row.QTESTOQDIA);
            totQTLANCTOEST += parseFloat(row.QTLANCTOEST);
            totVRESTOQDIA += parseFloat(row.VRESTOQDIA);
            totVRTOTLANCTO += parseFloat(row.VRTOTLANCTO);
            totDIASRESTANTES += parseFloat(row.DIASRESTANTES);
        });
        var mediaDias = totDIASRESTANTES / qtdeProdutos;
            
        if(filterPopup.DADOSPOR == '1'){
            widget.dataSource.data.push({"QTESTOQDIA": totQTESTOQDIA, "QTLANCTOEST": totQTLANCTOEST, "DIASRESTANTES": NaN, "CDLOCALESTOQ": "Totais"});
        } else if(filterPopup.DADOSPOR == '2'){
            widget.dataSource.data.push({"VRESTOQDIA": totVRESTOQDIA, "VRTOTLANCTO": totVRTOTLANCTO, "DIASRESTANTES": NaN, "CDLOCALESTOQ": "Totais"});
        }
            
        widget.dataSource.data.push({"QTESTOQDIA": NaN, "QTLANCTOEST": NaN, 
                                    "VRESTOQDIA": NaN, "VRTOTLANCTO": NaN, 
                                    "DIASRESTANTES": mediaDias, "CDLOCALESTOQ": "Nº médio de dias"});
        
        
        if(filterPopup.DADOSPOR == '1'){
            var qtdeMediaDia = (totQTESTOQDIA/totQTLANCTOEST)*filterPopup.NRDIAS;
            widget.dataSource.data.push({"QTESTOQDIA": NaN, "QTLANCTOEST": NaN, 
                                    "VRESTOQDIA": NaN, "VRTOTLANCTO": NaN, 
                                    "DIASRESTANTES": qtdeMediaDia, "CDLOCALESTOQ": "Qtde. média dia"});
        } else if(filterPopup.DADOSPOR == '2'){
            var vrMediaDia = (totVRESTOQDIA/totVRTOTLANCTO)*filterPopup.NRDIAS;
            widget.dataSource.data.push({"QTESTOQDIA": NaN, "QTLANCTOEST": NaN, 
                                    "VRESTOQDIA": NaN, "VRTOTLANCTO": NaN, 
                                    "DIASRESTANTES": vrMediaDia, "CDLOCALESTOQ": "Valor médio dia"});
        }
        */
    };
    
}

Configuration(function(ContextRegister) {
	ContextRegister.register('Est32000_GiroDeEstoque_Controller', Est32000_GiroDeEstoque_Controller);
});
